package main

import (
	"dubbo.apache.org/dubbo-go/v3/config"
	_ "dubbo.apache.org/dubbo-go/v3/filter/tps/strategy"
	_ "dubbo.apache.org/dubbo-go/v3/imports"
	exhibitionConfig "exhibition-register/config"
	"exhibition-register/internal/controller"
	_ "exhibition-register/internal/handler"
	"exhibition-register/pkg/app"
	common "exhibition-register/pkg/init"
	"exhibition-register/pkg/tracing"
	"github.com/bwmarrin/snowflake"
	"go.uber.org/zap"
	"gorm.io/gorm"
)

func NewApp(Lg *zap.Logger, JaegerTracer *tracing.JaegerProvider, SfNode *snowflake.Node, ExhibitionRegister *gorm.DB) *app.App {
	return &app.App{
		Lg:                 Lg,
		JaegerTracer:       JaegerTracer,
		SfNode:             SfNode,
		ExhibitionRegister: ExhibitionRegister,
	}
}

func main() {
	var err error
	exhibitionConfig.GetOptions()
	app.ModuleClients, err = InitApp()
	if err != nil {
		panic(err)
	}

	//l, err := net.Listen("tcp", ":8883")
	//if err != nil {
	//	fmt.Printf("failed to listen: %v", err)
	//	return
	//}
	//
	//s := grpc.NewServer()                               // 创建gRPC服务器
	//dci.RegisterDciServer(s, &controller.DciProvider{}) // 在gRPC服务端注册服务
	// 启动服务
	//err = s.Serve(l)
	//注册服务
	config.SetProviderService(&controller.ExhibitionProvider{})
	common.Init()
	if err = config.Load(); err != nil {
		panic(err)
	}
	select {}
}
